structure TRiver =
struct
  type     row         = int (* 0 < row *)
  type     column      = int (* 0 < column *)
  type     dockcnt     = int (* 1 <= dockcnt <= 7 *)
  datatype ftype       = River | Source | Lake | Meadow | Port of dockcnt
  type     location    = row * column
  type     bsize       = row * column
  type     field       = row * column * ftype
  type     rivermap    = bsize * field list
  type     riverpath   = location list
end
